//******************************************************************************
//    File: ItsxApplication.h
//  Module: trueSpace eXtensions API
//   Descr: Declarations for the ItsxApplication COM interface
//******************************************************************************


#ifndef ITSXAPPLICATION_H
#define ITSXAPPLICATION_H


#include "itsxcommon.h"

typedef struct ItsxDocument* PITSXDOCUMENT;


#undef INTERFACE
#define INTERFACE ItsxApplication

DECLARE_INTERFACE_(ItsxApplication, IUnknown)
{
	// IUnknown members
	STDMETHOD(QueryInterface) (THIS_ REFIID, PPVOID) PURE;
	STDMETHOD_(ULONG, AddRef)  (THIS) PURE;
	STDMETHOD_(ULONG, Release) (THIS) PURE;

	// ItsxApplication members
	STDMETHOD(GetTrueSpaceVersionNumbers) (THIS_ short*, short*) PURE;
	STDMETHOD(GetMainViewHwnd) (THIS_ HWND*) PURE;
	STDMETHOD(GetFirstDocument) (THIS_ PITSXDOCUMENT*) PURE;
	STDMETHOD(GetActiveDocument) (THIS_ PITSXDOCUMENT*) PURE;
};

// typedef a pointer to this interface
typedef ItsxApplication* PITSXAPPLICATION;

// define a GUID for this interface
// {B887D600-2F64-11d1-A255-006097D15F58}
DEFINE_GUID(IID_ItsxApplication, 0xb887d600, 0x2f64, 0x11d1, 0xa2, 0x55, 0x0, 0x60, 0x97, 0xd1, 0x5f, 0x58);


#endif // ITSXAPPLICATION_H