//******************************************************************************
//    File: ItsxDocument.h
//  Module: trueSpace eXtensions API
//   Descr: Declarations for the ItsxDocument COM interface
//******************************************************************************


#ifndef ITSXDOCUMENT_H
#define ITSXDOCUMENT_H


#include "itsxcommon.h"
#include "itsxobject.h"

// typedef a pointer to this interface
typedef struct ItsxDocument* PITSXDOCUMENT;


#undef INTERFACE
#define INTERFACE ItsxDocument

DECLARE_INTERFACE_(ItsxDocument, IUnknown)
{
	// IUnknown members
	STDMETHOD(QueryInterface) (THIS_ REFIID, PPVOID) PURE;
	STDMETHOD_(ULONG, AddRef)  (THIS) PURE;
	STDMETHOD_(ULONG, Release) (THIS) PURE;

	// ItsxDocument members
	STDMETHOD(GetNextDocument) (THIS_ PITSXDOCUMENT*) PURE;
	STDMETHOD(CreateTrueSpaceObject) (THIS_ CLSID, PITSXOBJECT*) PURE;
	STDMETHOD(Draw) (THIS) PURE;
	STDMETHOD(Render) (THIS) PURE;
	STDMETHOD(DrawActive) (THIS) PURE;
	STDMETHOD(RenderActive) (THIS) PURE;
};

// define a GUID for this interface
// {B887D601-2F64-11d1-A255-006097D15F58}
DEFINE_GUID(IID_ItsxDocument, 0xb887d601, 0x2f64, 0x11d1, 0xa2, 0x55, 0x0, 0x60, 0x97, 0xd1, 0x5f, 0x58);


#endif // ITSXDOCUMENT_H