//******************************************************************************
//    File: ItsxFog.h
//  Module: trueSpace eXtensions API
//   Descr: Declarations for the ItsxFog COM interface
//******************************************************************************


#ifndef ITSXFOG_H
#define ITSXFOG_H

#include "tsxcomtypes.h"
#include "itsxcommon.h"


#undef INTERFACE
#define INTERFACE ItsxFog

DECLARE_INTERFACE_(ItsxFog, IUnknown)
{
	// IUnknown members
	STDMETHOD(QueryInterface) (THIS_ REFIID, PPVOID) PURE;
	STDMETHOD_(ULONG, AddRef)  (THIS) PURE;
	STDMETHOD_(ULONG, Release) (THIS) PURE;

	// ItsxFog members
	STDMETHOD(QueryFog) (THIS) PURE;
	STDMETHOD(EnableFog) (THIS_ BOOL) PURE;
	STDMETHOD(GetFogColor) (THIS_ tsxColor*) PURE;
	STDMETHOD(SetFogColor) (THIS_ tsxColor*) PURE;
	STDMETHOD(GetFogDistance) (THIS_ float*, float*) PURE;
	STDMETHOD(SetFogDistance) (THIS_ float, float) PURE;
	STDMETHOD(GetFogDensity) (THIS_ float*) PURE;
	STDMETHOD(SetFogDensity) (THIS_ float) PURE;
};

// typedef a pointer to this interface
typedef ItsxFog* PITSXFOG;

// define a GUID for this interface
// {7AECD220-3007-11d1-A255-006097D15F58}
DEFINE_GUID(IID_ItsxFog, 0x7aecd220, 0x3007, 0x11d1, 0xa2, 0x55, 0x0, 0x60, 0x97, 0xd1, 0x5f, 0x58);


#endif // ITSXFOG_H