//******************************************************************************
//    File: ItsxGeometry.h
//  Module: trueSpace eXtensions API
//   Descr: Declarations for the ItsxGeometry COM interface
//******************************************************************************


#ifndef ITSXGEOMETRY_H
#define ITSXGEOMETRY_H


#include "tsxcomtypes.h"
#include "itsxcommon.h"


#undef INTERFACE
#define INTERFACE ItsxGeometry

DECLARE_INTERFACE_(ItsxGeometry, IUnknown)
{
	// IUnknown members
	STDMETHOD(QueryInterface) (THIS_ REFIID, PPVOID) PURE;
	STDMETHOD_(ULONG, AddRef)  (THIS) PURE;
	STDMETHOD_(ULONG, Release) (THIS) PURE;

	// ItsxGeometry members
	STDMETHOD(SetVisible) (THIS) PURE;
	STDMETHOD(SetInvisible) (THIS) PURE;
	STDMETHOD(Draw) (THIS) PURE;
	STDMETHOD(GetModelAxesOrientation) (THIS_ tsxAxes*) PURE;
	STDMETHOD(GetWorldAxesPosition) (THIS_ tsxVector*) PURE;
	STDMETHOD(GetWorldBoundingBox) (THIS_ tsxBoundingBox*) PURE;
	STDMETHOD(GetWorldPureTransform) (THIS_ tsxMatrix*) PURE;
	STDMETHOD(WorldRotate) (THIS_ tsxVector*, tsxVector*, float) PURE;
	STDMETHOD(ModelRotate) (THIS_ tsxVector*, tsxVector*, float) PURE;
	STDMETHOD(WorldScale) (THIS_ tsxVector*) PURE;
	STDMETHOD(ModelScale) (THIS_ tsxVector*) PURE;
	STDMETHOD(WorldTranslate) (THIS_ tsxVector*) PURE;
	STDMETHOD(ModelTranslate) (THIS_ tsxVector*) PURE;
	STDMETHOD(GetMatrix) (THIS_ tsxMatrix*) PURE;
	STDMETHOD(SetMatrix) (THIS_ tsxMatrix*) PURE;
	STDMETHOD(ShowAxes) (THIS) PURE;
	STDMETHOD(HideAxes) (THIS) PURE;
	STDMETHOD(GetAxesPosition) (THIS_ tsxVector*) PURE;
	STDMETHOD(SetAxesPosition) (THIS_ tsxVector*) PURE;
	STDMETHOD(GetAxesOrientation) (THIS_ tsxAxes*) PURE;
	STDMETHOD(SetAxesOrientation) (THIS_ tsxAxes*) PURE;

};

// typedef a pointer to this interface
typedef ItsxGeometry* PITSXGEOMETRY;

// define a GUID for this interface
// {E593B521-304E-11d1-A255-006097D15F58}
DEFINE_GUID(IID_ItsxGeometry, 0xe593b521, 0x304e, 0x11d1, 0xa2, 0x55, 0x0, 0x60, 0x97, 0xd1, 0x5f, 0x58);


#endif // ITSXGEOMETRY_H