//******************************************************************************
//    File: ItsxGlobalAnimation.h
//  Module: trueSpace eXtensions API
//   Descr: Declarations for the ItsxGlobalAnimation COM interface
//******************************************************************************


#ifndef ITSXGLOBALANIMATION_H
#define ITSXGLOBALANIMATION_H


#include "itsxcommon.h"

// typedef a pointer to this interface
typedef struct ItsxGlobalAnimation* PITSXGLOBALANIMATION;


#undef INTERFACE
#define INTERFACE ItsxGlobalAnimation

DECLARE_INTERFACE_(ItsxGlobalAnimation, IUnknown)
{
	// IUnknown members
	STDMETHOD(QueryInterface) (THIS_ REFIID, PPVOID) PURE;
	STDMETHOD_(ULONG, AddRef)  (THIS) PURE;
	STDMETHOD_(ULONG, Release) (THIS) PURE;

	// ItsxGlobalAnimation members
	STDMETHOD(GetActiveTime) (THIS_ float*) PURE;
	STDMETHOD(SetActiveTime) (THIS_ float) PURE;
	STDMETHOD(SetActiveObjectPlayMode) (THIS) PURE;
	STDMETHOD(SetDocumentPlayMode) (THIS) PURE;
	STDMETHOD(SetPlayRanges) (THIS_ float, float) PURE;
	STDMETHOD(Play) (THIS) PURE;

};

// define a GUID for this interface
DEFINE_GUID(IID_ItsxGlobalAnimation, 0xc1e429c0, 0x43cc, 0x11d1, 0xa2, 0x55, 0x0, 0x60, 0x97, 0xd1, 0x5f, 0x58);
// {C1E429C0-43CC-11d1-A255-006097D15F58}

#endif // ITSXGLOBALANIMATION_H