//******************************************************************************
//    File: ItsxLight.h
//  Module: trueSpace eXtensions API
//   Descr: Declarations for the ItsxLight COM interface
//******************************************************************************


#ifndef ITSXLIGHT_H
#define ITSXLIGHT_H

#include "tsxcomtypes.h"
#include "itsxcommon.h"


#undef INTERFACE
#define INTERFACE ItsxLight

DECLARE_INTERFACE_(ItsxLight, IUnknown)
{
	// IUnknown members
	STDMETHOD(QueryInterface) (THIS_ REFIID, PPVOID) PURE;
	STDMETHOD_(ULONG, AddRef)  (THIS) PURE;
	STDMETHOD_(ULONG, Release) (THIS) PURE;

	// ItsxLight members
	STDMETHOD(QueryInfinite) (THIS) PURE;
	STDMETHOD(QueryLocal) (THIS) PURE;
	STDMETHOD(QuerySpot) (THIS) PURE;
	STDMETHOD(SetInfinite) (THIS) PURE;
	STDMETHOD(SetLocal) (THIS) PURE;
	STDMETHOD(SetSpot) (THIS) PURE;
	STDMETHOD(GetColor) (THIS_ tsxColor*) PURE;
	STDMETHOD(SetColor) (THIS_ tsxColor*) PURE;
	STDMETHOD(QueryConstantFalloff) (THIS) PURE;
	STDMETHOD(QueryLinearFalloff) (THIS) PURE;
	STDMETHOD(QueryQuadraticFalloff) (THIS) PURE;
	STDMETHOD(SetConstantFalloff) (THIS) PURE;
	STDMETHOD(SetLinearFalloff) (THIS) PURE;
	STDMETHOD(SetQuadraticFalloff) (THIS) PURE;
	STDMETHOD(GetIntensity) (THIS_ float*) PURE;
	STDMETHOD(SetIntensity) (THIS_ float) PURE;
	STDMETHOD(QueryNoShadows) (THIS) PURE;
	STDMETHOD(QueryRaytracedShadows) (THIS) PURE;
	STDMETHOD(QueryShadowMappedShadows) (THIS) PURE;
	STDMETHOD(SetNoShadows) (THIS) PURE;
	STDMETHOD(SetRaytracedShadows) (THIS) PURE;
	STDMETHOD(SetShadowMappedShadows) (THIS) PURE;
	STDMETHOD(GetShadowMapSharpness) (THIS_ float*) PURE;
	STDMETHOD(SetShadowMapSharpness) (THIS_ float) PURE;
	STDMETHOD(GetShadowMapSize) (THIS_ float*) PURE;
	STDMETHOD(SetShadowMapSize) (THIS_ float) PURE;
	STDMETHOD(GetSpotAngle) (THIS_ float*) PURE;
	STDMETHOD(SetSpotAngle) (THIS_ float) PURE;
	STDMETHOD(GetSpotRatio) (THIS_ float*) PURE;
	STDMETHOD(SetSpotRatio) (THIS_ float) PURE;
	STDMETHOD(QueryShadowMapImageDependence) (THIS) PURE;
	STDMETHOD(SetShadowMapImageDependence) (THIS_ BOOL) PURE;
};

// typedef a pointer to this interface
typedef ItsxLight* PITSXLIGHT;

// define a GUID for this interface
// {7AECD221-3007-11d1-A255-006097D15F58}
DEFINE_GUID(IID_ItsxLight, 0x7aecd221, 0x3007, 0x11d1, 0xa2, 0x55, 0x0, 0x60, 0x97, 0xd1, 0x5f, 0x58);


#endif // ITSXLIGHT_H