//******************************************************************************
//    File: ItsxMath.h
//  Module: trueSpace eXtensions API
//   Descr: Declarations for the ItsxMath COM interface
//******************************************************************************


#ifndef ITSXMATH_H
#define ITSXMATH_H


#include "itsxcommon.h"
#include "tsxcomtypes.h"

typedef struct ItsxDocument* PITSXDOCUMENT;


#undef INTERFACE
#define INTERFACE ItsxMath

DECLARE_INTERFACE_(ItsxMath, IUnknown)
{
	// IUnknown members
	STDMETHOD(QueryInterface) (THIS_ REFIID, PPVOID) PURE;
	STDMETHOD_(ULONG, AddRef)  (THIS) PURE;
	STDMETHOD_(ULONG, Release) (THIS) PURE;

	// ItsxMath members
	STDMETHOD(Normalize) (THIS_ tsxVector*) PURE;
	STDMETHOD(Magnitude) (THIS_ tsxVector*, float*) PURE;
	STDMETHOD(MultiplyScalar) (THIS_ tsxVector*, float) PURE;
	STDMETHOD(AddVectorToVector) (THIS_ tsxVector*, tsxVector*) PURE;
	STDMETHOD(SubtractVectorFromVector) (THIS_ tsxVector*, tsxVector*) PURE;
	STDMETHOD(DotProduct) (THIS_ tsxVector*, tsxVector*, float*) PURE;
/*
	STDMETHOD(CrossProduct) (THIS_ tsxVector*, tsxVector*, tsxVector*) PURE;
	STDMETHOD(DistanceToLine) (THIS_ tsxVector*, tsxVector*, tsxVector*, float*) PURE;
	STDMETHOD(DistanceToPlane) (THIS_ tsxVector*, tsxVector*, tsxVector*, float*) PURE;
	STDMETHOD(GetMatrixTranslation) (THIS_ tsxMatrix*, tsxVector*) PURE;
	STDMETHOD(SetMatrixTranslation) (THIS_ tsxMatrix*, tsxVector*) PURE;
	STDMETHOD(AddMatrixTranslation) (THIS_ tsxMatrix*, tsxVector*) PURE;
	STDMETHOD(InvertMatrix) (THIS_ tsxMatrix*) PURE;
	STDMETHOD(MultiplyMatrix) (THIS_ tsxMatrix*, tsxMatrix*, tsxMatrix*) PURE;
*/
	STDMETHOD_(float, DegreesToRadians) (THIS_ float) PURE;
	STDMETHOD_(float, RadiansToDegrees) (THIS_ float) PURE;
};

// typedef a pointer to this interface
typedef ItsxMath* PITSXMATH;

// define a GUID for this interface
// {3B3F2640-3A3F-11d1-A255-006097D15F58}
DEFINE_GUID(IID_ItsxMath, 0x3b3f2640, 0x3a3f, 0x11d1, 0xa2, 0x55, 0x0, 0x60, 0x97, 0xd1, 0x5f, 0x58);


#endif // ITSXMATH_H