//******************************************************************************
//    File: ItsxPolyhedron.h
//  Module: trueSpace eXtensions API
//   Descr: Declarations for the ItsxPolyhedron COM interface
//******************************************************************************


#ifndef ITSXPOLYHEDRON_H
#define ITSXPOLYHEDRON_H


#include "itsxcommon.h"


#undef INTERFACE
#define INTERFACE ItsxPolyhedron

DECLARE_INTERFACE_(ItsxPolyhedron, IUnknown)
{
	// IUnknown members
	STDMETHOD(QueryInterface) (THIS_ REFIID, PPVOID) PURE;
	STDMETHOD_(ULONG, AddRef)  (THIS) PURE;
	STDMETHOD_(ULONG, Release) (THIS) PURE;

	// ItsxPolyhedron members
	STDMETHOD(Update) (THIS) PURE;
	STDMETHOD(Tessellate) (THIS) PURE;
	STDMETHOD(SetDefaultMaterial) (THIS) PURE;
	STDMETHOD(CopyFrom) (THIS_ ItsxPolyhedron*) PURE;
};

// typedef a pointer to this interface
typedef ItsxPolyhedron* PITSXPOLYHEDRON;

// define a GUID for this interface
// {BB099220-3436-11d1-A255-006097D15F58}
DEFINE_GUID(IID_ItsxPolyhedron, 0xbb099220, 0x3436, 0x11d1, 0xa2, 0x55, 0x0, 0x60, 0x97, 0xd1, 0x5f, 0x58);


#endif // ITSXPOLYHEDRON_H