//******************************************************************************
//    File: ItsxPolyhedronFace.h
//  Module: trueSpace eXtensions API
//   Descr: Declarations for the ItsxPolyhedronFace COM interface
//******************************************************************************


#ifndef ITSXPOLYHEDRONFACE_H
#define ITSXPOLYHEDRONFACE_H


#include "itsxcommon.h"


#undef INTERFACE
#define INTERFACE ItsxPolyhedronFace

DECLARE_INTERFACE_(ItsxPolyhedronFace, IUnknown)
{
	// IUnknown members
	STDMETHOD(QueryInterface) (THIS_ REFIID, PPVOID) PURE;
	STDMETHOD_(ULONG, AddRef)  (THIS) PURE;
	STDMETHOD_(ULONG, Release) (THIS) PURE;

	// ItsxPolyhedronFace members
	STDMETHOD_(ULONG, GetCount) (THIS) PURE;
	STDMETHOD(SetCount) (THIS_ ULONG) PURE;
	STDMETHOD(SetFirst) (THIS) PURE;
	STDMETHOD(SetNext) (THIS) PURE;
	STDMETHOD(Create) (THIS) PURE;
	STDMETHOD(Destroy) (THIS) PURE;
	STDMETHOD_(ULONG, GetVertexCount) (THIS) PURE;
	STDMETHOD(SetVertexCount) (THIS_ ULONG) PURE;
	STDMETHOD(SetFirstVertex) (THIS) PURE;
	STDMETHOD(SetNextVertex) (THIS) PURE;
	STDMETHOD_(ULONG, GetVertexIndex) (THIS) PURE;
	STDMETHOD(SetVertexIndex) (THIS_ ULONG) PURE;
	STDMETHOD_(ULONG, GetUVIndex) (THIS) PURE;
	STDMETHOD(SetUVIndex) (THIS_ ULONG) PURE;
	STDMETHOD(AttachVertex) (THIS_ ULONG, ULONG) PURE;
	STDMETHOD(GetNormalVertices) (THIS_ ULONG*, ULONG*, ULONG*) PURE;
	STDMETHOD(SetNormalVertices) (THIS_ ULONG, ULONG, ULONG) PURE;
	STDMETHOD(GetVertexColor) (THIS_ tsxColor*) PURE;
	STDMETHOD(SetVertexColor) (THIS_ tsxColor*) PURE;
	STDMETHOD(GetNormal) (THIS_ tsxVector*) PURE;
	STDMETHOD(Render) (THIS) PURE;

};

// typedef a pointer to this interface
typedef ItsxPolyhedronFace* PITSXPOLYHEDRONFACE;

// define a GUID for this interface
// {AA8273A2-34C6-11d1-A255-006097D15F58}
DEFINE_GUID(IID_ItsxPolyhedronFace, 0xaa8273a2, 0x34c6, 0x11d1, 0xa2, 0x55, 0x0, 0x60, 0x97, 0xd1, 0x5f, 0x58);


#endif // ITSXPOLYHEDRONFACE_H