//******************************************************************************
//    File: ItsxPolyhedronUV.h
//  Module: trueSpace eXtensions API
//   Descr: Declarations for the ItsxPolyhedronUV COM interface
//******************************************************************************


#ifndef ITSXPOLYHEDRONUV_H
#define ITSXPOLYHEDRONUV_H


#include "itsxcommon.h"


#undef INTERFACE
#define INTERFACE ItsxPolyhedronUV

DECLARE_INTERFACE_(ItsxPolyhedronUV, IUnknown)
{
	// IUnknown members
	STDMETHOD(QueryInterface) (THIS_ REFIID, PPVOID) PURE;
	STDMETHOD_(ULONG, AddRef)  (THIS) PURE;
	STDMETHOD_(ULONG, Release) (THIS) PURE;

	// ItsxPolyhedronUV members
	STDMETHOD_(ULONG, GetCount) (THIS) PURE;
	STDMETHOD(SetCount) (THIS_ ULONG) PURE;
	STDMETHOD(SetFirst) (THIS) PURE;
	STDMETHOD(SetNext) (THIS) PURE;
	STDMETHOD(Create) (THIS) PURE;
	STDMETHOD(Destroy) (THIS) PURE;
	STDMETHOD(GetPosition) (THIS_ tsxUV*) PURE;
	STDMETHOD(SetPosition) (THIS_ tsxUV*) PURE;
};

// typedef a pointer to this interface
typedef ItsxPolyhedronUV* PITSXPOLYHEDRONUV;

// define a GUID for this interface
// {5FCC5500-6299-11d1-A256-006097D15F58}
DEFINE_GUID(IID_ItsxPolyhedronUV, 0x5fcc5500, 0x6299, 0x11d1, 0xa2, 0x56, 0x0, 0x60, 0x97, 0xd1, 0x5f, 0x58);


#endif // ITSXPOLYHEDRONUV_H