//******************************************************************************
//    File: ItsxPolyhedronVertex.h
//  Module: trueSpace eXtensions API
//   Descr: Declarations for the ItsxPolyhedronVertex COM interface
//******************************************************************************


#ifndef ITSXPOLYHEDRONVERTEX_H
#define ITSXPOLYHEDRONVERTEX_H


#include "itsxcommon.h"


#undef INTERFACE
#define INTERFACE ItsxPolyhedronVertex

DECLARE_INTERFACE_(ItsxPolyhedronVertex, IUnknown)
{
	// IUnknown members
	STDMETHOD(QueryInterface) (THIS_ REFIID, PPVOID) PURE;
	STDMETHOD_(ULONG, AddRef)  (THIS) PURE;
	STDMETHOD_(ULONG, Release) (THIS) PURE;

	// ItsxPolyhedronVertex members
	STDMETHOD_(ULONG, GetCount) (THIS) PURE;
	STDMETHOD(SetCount) (THIS_ ULONG) PURE;
	STDMETHOD(SetFirst) (THIS) PURE;
	STDMETHOD(SetNext) (THIS) PURE;
	STDMETHOD(Create) (THIS) PURE;
	STDMETHOD(Destroy) (THIS) PURE;
	STDMETHOD(GetPosition) (THIS_ tsxVector*) PURE;
	STDMETHOD(SetPosition) (THIS_ tsxVector*) PURE;
};

// typedef a pointer to this interface
typedef ItsxPolyhedronVertex* PITSXPOLYHEDRONVERTEX;

// define a GUID for this interface
// {AA8273A0-34C6-11d1-A255-006097D15F58}
DEFINE_GUID(IID_ItsxPolyhedronVertex, 0xaa8273a0, 0x34c6, 0x11d1, 0xa2, 0x55, 0x0, 0x60, 0x97, 0xd1, 0x5f, 0x58);


#endif // ITSXPOLYHEDRONVERTEX_H