//******************************************************************************
//    File: ItsxPrimitives.h
//  Module: trueSpace eXtensions API
//   Descr: Declarations for the ItsxPrimitives COM interface
//******************************************************************************


#ifndef ITSXPRIMITIVES_H
#define ITSXPRIMITIVES_H


#include "itsxcommon.h"


#undef INTERFACE
#define INTERFACE ItsxPrimitives

DECLARE_INTERFACE_(ItsxPrimitives, IUnknown)
{
	// IUnknown members
	STDMETHOD(QueryInterface) (THIS_ REFIID, PPVOID) PURE;
	STDMETHOD_(ULONG, AddRef)  (THIS) PURE;
	STDMETHOD_(ULONG, Release) (THIS) PURE;

	// ItsxPrimitives members
	STDMETHOD(CreateCone) (THIS_ int, int, float, float) PURE;
	STDMETHOD(CreateCube) (THIS_ int, float, float, float) PURE;
	STDMETHOD(CreateCylinder) (THIS_ int, int, float, float, float) PURE;
	STDMETHOD(CreatePlane) (THIS_ int, int) PURE;
	STDMETHOD(CreateSphere) (THIS_ int, int, float) PURE;
	STDMETHOD(CreateTorus) (THIS_ int, int, float) PURE;
};

// typedef a pointer to this interface
typedef ItsxPrimitives* PITSXPRIMITIVES;

// define a GUID for this interface
// {B887D602-2F64-11d1-A255-006097D15F58}
DEFINE_GUID(IID_ItsxPrimitives, 0xb887d602, 0x2f64, 0x11d1, 0xa2, 0x55, 0x0, 0x60, 0x97, 0xd1, 0x5f, 0x58);


#endif // ITSXPRIMITIVES_H