//******************************************************************************
//    File: ItsxView.h
//  Module: trueSpace eXtensions API
//   Descr: Declarations for the ItsxView COM interface
//******************************************************************************


#ifndef ITSXVIEW_H
#define ITSXVIEW_H


#include "itsxcommon.h"
#include "tsxcomtypes.h"


#undef INTERFACE
#define INTERFACE ItsxView

DECLARE_INTERFACE_(ItsxView, IUnknown)
{
	// IUnknown members
	STDMETHOD(QueryInterface) (THIS_ REFIID, PPVOID) PURE;
	STDMETHOD_(ULONG, AddRef)  (THIS) PURE;
	STDMETHOD_(ULONG, Release) (THIS) PURE;

	// ItsxView members
	STDMETHOD(Draw) (THIS) PURE;
	STDMETHOD(Render) (THIS) PURE;
	STDMETHOD(DrawActive) (THIS) PURE;
	STDMETHOD(RenderActive) (THIS) PURE;
	STDMETHOD(GetHwnd) (THIS_ HWND* Handle) PURE;
	STDMETHOD(GetPosition) (THIS_ tsxVector*) PURE;
	STDMETHOD(SetPosition) (THIS_ tsxVector*) PURE;
	STDMETHOD(GetDirection) (THIS_ tsxVector*) PURE;
	STDMETHOD(SetDirection) (THIS_ tsxVector*) PURE;
	STDMETHOD(LookAt) (THIS_ tsxVector*) PURE;
	STDMETHOD(GetBankAngle) (THIS_ float*) PURE;
	STDMETHOD(SetBankAngle) (THIS_ float) PURE;
	STDMETHOD(GetZoom) (THIS_ float*) PURE;
	STDMETHOD(SetZoom) (THIS_ float) PURE;
	STDMETHOD(GetWorldToEyeMatrix) (THIS_ tsxMatrix*) PURE;
	STDMETHOD(GetEyeToWorldMatrix) (THIS_ tsxMatrix*) PURE;
	STDMETHOD(GetWorldToViewportMatrix) (THIS_ tsxMatrix*) PURE;
	STDMETHOD(GetMouseRay) (THIS_ short, short, tsxVector*, tsxVector*) PURE;
};

// typedef a pointer to this interface
typedef ItsxView* PITSXVIEW;

// define a GUID for this interface
// {5DFAD700-4616-11d1-A255-006097D15F58}
DEFINE_GUID(IID_ItsxView, 0x5dfad700, 0x4616, 0x11d1, 0xa2, 0x55, 0x0, 0x60, 0x97, 0xd1, 0x5f, 0x58);


#endif // ITSXVIEW_H