//******************************************************************************
//    File: tsxCOMTypes.h
//  Module: trueSpace eXtensions API
//   Descr: Data types used by the tsxCOM interface
//******************************************************************************

#ifndef TSXCOMTYPES_H
#define TSXCOMTYPES_H


// Three-dimensional vector
struct tsxVector
{
	float x;	// X coordinate
	float y;	// Y coordinate
	float z;	// Z coordinate
};


// Bounding Box
struct tsxBoundingBox
{
	tsxVector minbounds; // Minimum X, Y, Z coordinates
	tsxVector maxbounds; // Maximum X, Y, Z coodinates
};


// Axes
struct tsxAxes
{
	tsxVector xaxis;  // Unit vector specifying orientation of X axis
	tsxVector yaxis;  // Unit vector specifying orientation of Y axis
	tsxVector zaxis;  // Unit vector specifying orientation of Z axis
};


// Transformation Matrix
struct tsxMatrix
{
	float matrix[3][4];
};


// Color
struct tsxColor
{
	unsigned char red;		// 0 - 255
	unsigned char green;	// 0 - 255
	unsigned char blue;		// 0 - 255
	unsigned char alpha;	// 0 - 100
};


// UV texture-space coordinates
struct tsxUV
{
	float u;
	float v;
};



#endif // TSXCOMTYPES_H
