//******************************************************************************
//    File: tsxCamra.h
//  Module: trueSpace eXtensions API
//   Descr: Interface to tsxCAMERA
//******************************************************************************

#ifndef TSXCAMRA_H
#define TSXCAMRA_H


#include "tsxTypes.h"


//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

// A Camera is a GNode, with some special properties as mentioned below.
// See also "tsxAView.h"

//------------------------------------------------------------------------------
//	Managers
//------------------------------------------------------------------------------

// Creates a camera at world origin, with the viewing plane on the world
// YZ plane, Z in the up direction, and pointing in the positive world X
// direction. On success, the new camera is the currently selected object.
TSXAPIFN tsxERR tsxCameraCreateInScene();

// Use `tsxSobjDelete' to remove and delete from scene, and GNODE functions
// to manage in the scene graph and access/modify position.

// Scaling along Camera's Z axis changes ZOOM.
// Use GNODE rotation and translation functions to point the camera at an object.


//******************************************************************************
#endif // TSXCAMRA_H
