//******************************************************************************
//    File: tsxSobj.h
//  Module: trueSpace eXtensions API
//   Descr: Definition of tsxSOBJ
//******************************************************************************

#ifndef TSXSOBJ_H
#define TSXSOBJ_H


#include "tsxTypes.h"


//------------------------------------------------------------------------------
//------------------------------------------------------------------------------

// A tsxSOBJ is the most abstract type for objects associated with a
// trueSpace Scene.
// It contains the following information:
//	- Object Type

//------------------------------------------------------------------------------
//	Sobj Type
//------------------------------------------------------------------------------

// Sobj Type
TSXAPIFN tsxSOBJTYPE tsxSobjGetType( tsxSOBJ* pSobj );


// e_tsxTRUE if Node is a Sobj
TSXAPIFN tsxBOOL tsxIsSobj( tsxSOBJ* pSobj );

// Get the first child of an object.
TSXAPIFN tsxSOBJ* tsxSobjGetFirstChild( tsxSOBJ* pSobj );

// Get the last child of an object.
TSXAPIFN tsxSOBJ* tsxSobjGetLastChild( tsxSOBJ* pSobj );

// Get the next node of valid tsx Sobj Type
// pSobj is any Calobj
TSXAPIFN tsxSOBJ* tsxSobjGetNext( tsxSOBJ* pSobj );

// Get the prev node of valid tsx Sobj Type
// pSobj is any Calobj
TSXAPIFN tsxSOBJ* tsxSobjGetPrev( tsxSOBJ* pSobj );

// Add a new child to a parent node.
TSXAPIFN tsxERR tsxSobjAddChild( tsxSOBJ* pParent, tsxSOBJ* pNewChild );

//------------------------------------------------------------------------------
//	Manage
//------------------------------------------------------------------------------

// Delete and free memory, including internal allocations.
// Also delete all children, if any.
// Erases objects from all Views.
TSXAPIFN void tsxSobjDelete( tsxSOBJ* pSobj );

//******************************************************************************
#endif //TSXSOBJ_H
